%{
#include <stdio.h>

#include "doom3map_parser.tab.h++"

%}
%x IN_COMMENT


DIGIT                           [0-9]


%%

<INITIAL>{
"/*"                            BEGIN(IN_COMMENT);
}
<IN_COMMENT>{
"*/"                            BEGIN(INITIAL);
[^*\n]+
"*"
\n                              yylineno++;
}

\[.*\]				;
\"[^\"]*\"			{ yylval.string = strndup (yytext + 1, yyleng - 2); return STRING; }
-?{DIGIT}+                      { yylval.num = atof (yytext); return NUMBER; }
[-+]?{DIGIT}+"."{DIGIT}*        { yylval.num = atof (yytext); return NUMBER; }

\/\/.*				;

[\040\t\r,]			;
\n				yylineno++;

[\;\{\}()]			return yytext[0];

model                           return MODEL;

interAreaPortals                return IAPO;         
nodes                           return NODES;
shadowModel                     return SHADOWMODEL;

[A-Za-z0-9_]+                    { yylval.string = strndup (yytext, yyleng); return ID; }

%%

int yywrap ()
{
  return 1;
}


