#include "shader_vars.h"

namespace shader {
  namespace compile {
    struct vin vin;

#if 0
    varying_3f vin::vertex_3f  ("gl_Vertex");
    varying_4f vin::vertex_4f  ("gl_Vertex");
    varying_3f vin::normal_3f  ("gl_Normal");
    varying_3f vin::color_3f   ("gl_Color");
    varying_4f vin::color_4f   ("gl_Color");
    varying_3f vin::secondary_color_3f ("gl_SecondaryColor");
    varying_4f vin::secondary_color_4f ("gl_SecondaryColor");
    varying_1f vin::tex_coord_1f[8] =
      {
        varying_1f ("gl_TexCoord[0]"), varying_1f ("gl_TexCoord[1]"), varying_1f ("gl_TexCoord[2]"), varying_1f ("gl_TexCoord[3]"),
        varying_1f ("gl_TexCoord[4]"), varying_1f ("gl_TexCoord[5]"), varying_1f ("gl_TexCoord[6]"), varying_1f ("gl_TexCoord[7]"),
      };
    varying_2f vin::tex_coord_2f[8] =
      {
        varying_2f ("gl_TexCoord[0]"), varying_2f ("gl_TexCoord[1]"), varying_2f ("gl_TexCoord[2]"), varying_2f ("gl_TexCoord[3]"),
        varying_2f ("gl_TexCoord[4]"), varying_2f ("gl_TexCoord[5]"), varying_2f ("gl_TexCoord[6]"), varying_2f ("gl_TexCoord[7]"),
      };
    varying_3f vin::tex_coord_3f[8] =
      {
        varying_3f ("gl_TexCoord[0]"), varying_3f ("gl_TexCoord[1]"), varying_3f ("gl_TexCoord[2]"), varying_3f ("gl_TexCoord[3]"),
        varying_3f ("gl_TexCoord[4]"), varying_3f ("gl_TexCoord[5]"), varying_3f ("gl_TexCoord[6]"), varying_3f ("gl_TexCoord[7]"),
      };
    varying_4f vin::tex_coord_4f[8] =
      {
        varying_4f ("gl_TexCoord[0]"), varying_4f ("gl_TexCoord[1]"), varying_4f ("gl_TexCoord[2]"), varying_4f ("gl_TexCoord[3]"),
        varying_4f ("gl_TexCoord[4]"), varying_4f ("gl_TexCoord[5]"), varying_4f ("gl_TexCoord[6]"), varying_4f ("gl_TexCoord[7]"),
      };
#endif

    gluvar const vin::vertex ("gl_Vertex");
    gluvar const vin::normal ("gl_Normal");
    gluvar const vin::color  ("gl_Color");
    gluvar const vin::secondary_color ("gl_SecondaryColor");
    gluvar const vin::tex_coord[8] =
      {
        gluvar ("gl_MultiTexCoord0"), gluvar ("gl_MultiTexCoord1"), gluvar ("gl_MultiTexCoord2"), gluvar ("gl_MultiTexCoord3"),
        gluvar ("gl_MultiTexCoord4"), gluvar ("gl_MultiTexCoord5"), gluvar ("gl_MultiTexCoord6"), gluvar ("gl_MultiTexCoord7"),
      };
    gluvar const vin::fog_coord ("gl_FogCoord");

    struct vout vout;

    gluvar const vout::position    ("gl_Position");
    gluvar const vout::point_size  ("gl_PointSize");
    gluvar const vout::clip_vertex ("gl_ClipVertex");
    gluvar const vout::front_color ("gl_FontColor");
    gluvar const vout::back_color  ("gl_BackColor");
    gluvar const vout::front_secondary_color ("gl_FrontSecondaryColor");
    gluvar const vout::back_secondary_color ("gl_BackSecondaryColor");
    gluvar const vout::tex_coord[8] =
      {
        gluvar ("gl_TexCoord[0]"), gluvar ("gl_TexCoord[1]"), gluvar ("gl_TexCoord[2]"), gluvar ("gl_TexCoord[3]"),
        gluvar ("gl_TexCoord[4]"), gluvar ("gl_TexCoord[5]"), gluvar ("gl_TexCoord[6]"), gluvar ("gl_TexCoord[7]"),
      };
    gluvar const vout::fog_frag_coord ("gl_FogFragCoord");

    struct fin fin;

    gluvar const fin::frag_coord      ("gl_FragCoord");
    gluvar const fin::front_facing    ("gl_FrontFacing");
    gluvar const fin::color           ("gl_Color");
    gluvar const fin::secondary_color ("gl_SecondaryColor");
    gluvar const fin::tex_coord[8] =
      {
        gluvar ("gl_TexCoord[0]"), gluvar ("gl_TexCoord[1]"), gluvar ("gl_TexCoord[2]"), gluvar ("gl_TexCoord[3]"),
        gluvar ("gl_TexCoord[4]"), gluvar ("gl_TexCoord[5]"), gluvar ("gl_TexCoord[6]"), gluvar ("gl_TexCoord[7]"),
      };
    gluvar const fin::fog_frag_coord  ("gl_FogFragCoord");

    struct fout fout;

    gluvar const fout::frag_color     ("gl_FragColor");
    gluvar const fout::frag_depth     ("gl_FragDepth");
    gluvar const fout::frag_data[2] = { gluvar ("gl_FragData[0]"), gluvar ("gl_FragData[1]") };

    gluvar model_view_matrix ("gl_ModelViewMatrix"),
           projection_matrix ("gl_ProjectionMatrix"),
           model_view_projection_matrix ("gl_ModelViewProjectionMatrix"),
           texture_matrix[8] =
             {
               gluvar ("gl_TextureMatrix[0]"), gluvar ("gl_TextureMatrix[1]"),
               gluvar ("gl_TextureMatrix[2]"), gluvar ("gl_TextureMatrix[3]"),
               gluvar ("gl_TextureMatrix[4]"), gluvar ("gl_TextureMatrix[5]"),
               gluvar ("gl_TextureMatrix[6]"), gluvar ("gl_TextureMatrix[7]"),
             };
    gluvar model_view_matrix_inverse ("gl_ModelViewMatrixInverse"),
           projection_matrix_inverse ("gl_ProjectionMatrixInverse"),
           model_view_projection_matrix_inverse ("gl_ModelViewProjectionMatrixInverse"),
           texture_matrix_inverse[8] =
             {
               gluvar ("gl_TextureMatrixInverse[0]"), gluvar ("gl_TextureMatrixInverse[1]"),
               gluvar ("gl_TextureMatrixInverse[2]"), gluvar ("gl_TextureMatrixInverse[3]"),
               gluvar ("gl_TextureMatrixInverse[4]"), gluvar ("gl_TextureMatrixInverse[5]"),
               gluvar ("gl_TextureMatrixInverse[6]"), gluvar ("gl_TextureMatrixInverse[7]"),
             };
     gluvar model_view_matrix_transpose ("gl_ModelViewMatrixTranspose"),
           projection_matrix_transpose ("gl_ProjectionMatrixTranspose"),
           model_view_projection_matrix_transpose ("gl_ModelViewProjectionMatrixTranspose"),
           texture_matrix_transpose[8] =
             {
               gluvar ("gl_TextureMatrixTranspose[0]"), gluvar ("gl_TextureMatrixTranspose[1]"),
               gluvar ("gl_TextureMatrixTranspose[2]"), gluvar ("gl_TextureMatrixTranspose[3]"),
               gluvar ("gl_TextureMatrixTranspose[4]"), gluvar ("gl_TextureMatrixTranspose[5]"),
               gluvar ("gl_TextureMatrixTranspose[6]"), gluvar ("gl_TextureMatrixTranspose[7]"),
             };
    gluvar model_view_matrix_inverse_transpose ("gl_ModelViewMatrixInverseTranspose"),
           projection_matrix_inverse_transpose ("gl_ProjectionMatrixInverseTranspose"),
           model_view_projection_matrix_inverse_transpose ("gl_ModelViewProjectionMatrixInverseTranspose"),
           texture_matrix_inverse_transpose[8] =
             {
               gluvar ("gl_TextureMatrixInverseTranspose[0]"), gluvar ("gl_TextureMatrixInverseTranspose[1]"),
               gluvar ("gl_TextureMatrixInverseTranspose[2]"), gluvar ("gl_TextureMatrixInverseTranspose[3]"),
               gluvar ("gl_TextureMatrixInverseTranspose[4]"), gluvar ("gl_TextureMatrixInverseTranspose[5]"),
               gluvar ("gl_TextureMatrixInverseTranspose[6]"), gluvar ("gl_TextureMatrixInverseTranspose[7]"),
             };

    gluvar normal_matrix            ("gl_NormalMatrix");

    gluvar normal_scale             ("gl_NormalScale");
    gluvar depth_range_near         ("gl_DepthRange.near"),
           depth_range_far          ("gl_DepthRange.far"),
           depth_range_diff         ("gl_DepthRange.diff");

    gluvar clip_plane[2] = { gluvar ("gl_ClipPlane[0]"), gluvar ("gl_ClipPlane[1]") };

    gluvar front_material_emission  ("gl_FrontMaterialEmission"),
           front_material_ambient   ("gl_FrontMaterialAmbient"),
           front_material_diffuse   ("gl_FrontMaterialDiffuse"),
           front_material_specular  ("gl_FrontMaterialSpecular"),
           front_material_shininess ("gl_FrontMaterialShininess");
    gluvar back_material_emission   ("gl_BackMaterialEmission"),
           back_material_ambient    ("gl_BackMaterialAmbient"),
           back_material_diffuse    ("gl_BackMaterialDiffuse"),
           back_material_specular   ("gl_BackMaterialSpecular"),
           back_material_shininess  ("gl_BackMaterialShininess");

    gluvar light_model_ambient      ("gl_LightModel.ambient");
    gluvar front_light_model_product_scene_color ("gl_FrontLightModelProduct.sceneColor");
    gluvar back_light_model_product_scene_color  ("gl_BackLightModelProduct.sceneColor");
  }
}


